/*  Promile Qt - calculates amount of alcohol in your body
  *  Copyright (C) 2008  Marcin Dombrowski
  *
  *  This program is free software: you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation, either version 3 of the License, or
  *  (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU General Public License for more details.
  *
  *  You should have received a copy of the GNU General Public License
  *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <iostream>
#include "promile-qt.h"
#include "ui_promile-qt.h"
#include <string.h>
#define ILOSC_NAPOJOW 100

using namespace Ui;

extern Form ui;

class napoj; // deklaracja klasy
float wspolczynnik, waga, masa=0,ostatni=0,pierwszy=0, cz=0,ile_na_godz;
napoj * napoje[ILOSC_NAPOJOW];
int nr_napoju = 0;
char odp,zaawansowane='n';
const float gestosc = 0.79;

class napoj
{
	public:
		int ilosc;              //objętość napoju [ml]
		int dlugosc_picia;      //czas spożywania teo napoju [minut]
		float stezenie;         //zawartość alkoholu [% v/v]
		float godzina;          //godzina rozpoczęcia picia
		float czas_wchlaniania; //czas po którym alkohol dostaje się do krwi
		float ile_wypite;       //ile ml wypite w danym czasie
		char spr;		//czy wypite całe
		napoj (int,float,float,float,int);
		~napoj();
};

napoj::napoj (int il, float st, float godz, float cz_wchl, int dl_pic)
{
	ilosc=il;
	stezenie=st;
	godzina=godz+cz_wchl;
	czas_wchlaniania=cz_wchl;
	ile_wypite=0;
	dlugosc_picia=dl_pic;
	spr='n';
}

napoj::~napoj ()
{
nr_napoju=nr_napoju-1;
ostatni=0;
pierwszy=0;
}

float spytaj_o_plec(char plec)
{


	switch (plec)
	{
		case 'k' :
			return 0.6;
			break;

		case 'm' :
			return 0.7;
			break;

		default :
			return 0.7;
			break;
	}
}

float m_alk(float czas)
{	
	float poprz_masa;
	int nap; // numer napoju
	masa=0;
	czas=czas; // godziny zamieniane na minuty (dla dokładności)
	for (cz=0; cz <= czas; cz = cz + 1) // liczymy z dokładnością co do minuty
	{

		poprz_masa=masa; // zapamiętanie poprzedniej masy alkoholu
		for (nap=1 ; nap<=nr_napoju ; nap=nap+1)
		{
			if (((cz) >= napoje[nap]->godzina) && (napoje[nap]->spr=='n' ))
			{
				masa = masa + ( (napoje[nap]->ilosc) / (napoje[nap]->dlugosc_picia))*\
				((napoje[nap]->stezenie)/100 * gestosc);
				
				napoje[nap]->ile_wypite = napoje[nap]->ile_wypite + \
				((napoje[nap]->ilosc) / (napoje[nap]->dlugosc_picia));
				
				if (napoje[nap]->ile_wypite>=napoje[nap]->ilosc) {napoje[nap]->spr='t';}
			}
		}
		if ((cz>0) && (poprz_masa!=0)){masa=masa-(ile_na_godz/60.0);}
		if (masa<0){masa=0;}
	}


	// oznaczanie jako niewypite
	for (nap=1 ; nap<=nr_napoju ; nap=nap+1)
	{
		napoje[nap]->spr='n';
		napoje[nap]->ile_wypite=0;
	}

	return masa;
}

void Form1::dodaj_napoj(int ilosc, float godzina, float stezenie, float cz_wchl, int dl_pic)
{

		nr_napoju++;
		if (nr_napoju==1)
		{
			pierwszy=godzina; // ustawienie pierwszego napoju
		}
		else
		{
			if(godzina<pierwszy) {pierwszy=godzina;}
		}
		
		if (nr_napoju>=ILOSC_NAPOJOW)
		{
			ui.textBrowser_napoje->insertHtml("Osiagnieto limit napojow");
			nr_napoju--;
			return;
		}

		napoje[nr_napoju] = new napoj(ilosc,stezenie,godzina,cz_wchl,dl_pic);

		ui.textBrowser_napoje->append("<b>Dodano " + QString::number(nr_napoju) + " napoj: </b>" + QString::number(ui.spinBox_ilosc->value()) +  " ml " + QString::number(ui.doubleSpinBox_zawartosc->value()) + " % dzien " + QString::number(ui.spinBox_czas_dzien->value()) +" godzina " + QString::number(ui.spinBox_czas_godz->value()) + ":" + QString::number(ui.spinBox_czas_min->value()));
		
		if(godzina+cz_wchl+dl_pic>ostatni)
		{
			ostatni=godzina+cz_wchl+dl_pic; // godzina wchloniecia ostatniego napoju
		}
}

float promile(float czas)
{
	float P;
	P=(m_alk(czas)/waga/wspolczynnik);
	return P;
}

void kasuj_napoje(void)
{
	int nap;
	int ilosc_napoi;
	ilosc_napoi=nr_napoju;
	for (nap=1; nap<=ilosc_napoi;nap++)
	{
		napoje[nap]->~napoj();		
	}
}


void Form1::wyswietl_tytul_tabeli()
{
ui.textEdit->insertHtml("<table border=\"0\" width=\"300\"><tr><td><b>Godzina</b></td><td><b>Stezenie we krwi [&permil;]</b></td></tr></table>");

}

void Form1::bmi_info(float waga)
{
	float bmi=(waga/((ui.spinBox_wzrost->value()/100.0)*(ui.spinBox_wzrost->value()/100.0)));

	if (bmi>=25)
	{
		ui.textEdit->insertHtml("\nTwoj indeks masy ciala wynosi " + QString::number(bmi) + \
				" i moze wskazywac na nadwage.\nJesli jest tak naprawde to obliczona zawartosc alkoholu we krwi \n\
				jest wieksza niz w rzeczywistosci");
	}

	if (bmi<18.5)
	{
		ui.textEdit->insertHtml("\nTwoj indeks masy ciala wynosi "+ QString::number(bmi) + \
				" i moze wskazywac na niedowage. \nJesli jest tak napawde to obliczona zawartosc alkoholu we krwi \n\
				jest mniejsza niz w rzeczywistosci");
	}

}

//////////////////////////////////////
//             M A I N              //
//////////////////////////////////////
void Form1::glowna (char plec, float masa, int co_ile_minut,float ing)
{
	float wynik,spr_godz=0;
	int godziny,minuty,dzien;
	wspolczynnik=spytaj_o_plec(plec);
	waga=masa;
	ile_na_godz=ing*wspolczynnik;
	char wyswietl[150];
	char * o1, * o2,* z1,* z2; //znaczniki otwierające i zamykające

	spr_godz=pierwszy;
	wyswietl_tytul_tabeli();
	while ((spr_godz<=ostatni) || ((spr_godz>ostatni) && (promile(spr_godz-co_ile_minut)!=0)) )	
	{
		dzien = int (spr_godz/(24*60.0));
		godziny = int (spr_godz - 24*60*dzien)/60;
		minuty = int (spr_godz - 24*60*dzien - godziny*60);
		dzien=dzien+1; //aby pierwszy dzien by 1 a nie 0
		wynik=promile(spr_godz);		


		if (((minuty + godziny*60)-co_ile_minut <0) || ((dzien-1)*24*60+(minuty + godziny*60)-co_ile_minut <pierwszy) )
		{
			ui.textEdit->append("\n");
			ui.textEdit->insertHtml("<b>Dzien " + QString::number(dzien) + "</b>");
		}	

		if ((wynik>=ui.doubleSpinBox_dop_stez->value() && wynik>0)) //wyświetl na czerwono jeśli poqyżęj dopuszczalnego stenia
		{
			o1="<table border=\"0\" width=\"300\"><tr><p><td><font color=red>";
			z1="</font></td>";
			o2="<td><font color=red>";
			z2="</font></td></p></tr><table>";
		}
		else
		if (wynik==0) // na zielono kiedy 0 promili
		{
			o1="<table border=\"0\" width=\"300\"><tr><p><td><font color=\"#00CC00\">";
			z1="</font></td>";
			o2="<td><font color=\"#00CC00\">";
			z2="</font></td></p></tr><table>";
		}
		else
		{
			o1="<table border=\"0\" width=\"300\"><tr><p><td><font color=\"#FF7700\">"; // na pomaraczowo kiedy 0<promile<dopuszczalne
			z1="</font></td>";
			o2="<td><font color=\"#FF7700\">";
			z2="</font></td></p></tr><table>";
		}

		if (wynik>=ui.doubleSpinBox_dawka_smiertelna->value())
		{
		sprintf(wyswietl, "%s%s%02i%s%02i%s%s%.3f%s%s" ,"<b>", o1,godziny ,":",minuty,z1,o2, wynik,z2,"</b>");
		}
		else
		{
		sprintf(wyswietl, "%s%02i%s%02i%s%s%.3f%s" , o1,godziny ,":",minuty,z1,o2, wynik,z2);
		}
		ui.textEdit->insertHtml(wyswietl);
		spr_godz=spr_godz+co_ile_minut;
	}
bmi_info(waga); //wywietl informacje o bmi

}
